# This patch file was generated by NetBeans IDE
# This patch can be applied using context Tools: Apply Diff Patch action on respective folder.
# It uses platform neutral UTF-8 encoding.
# Above lines and this line are ignored by the patching process.
Index: moodle/blog/edit.php
--- moodle/blog/edit.php Base (1.73)
+++ moodle/blog/edit.php Locally Modified (Based On 1.73)
@@ -99,7 +99,9 @@
     } else {
         $optionsyes = array('id'=>$id, 'action'=>'delete', 'confirm'=>1, 'sesskey'=>sesskey(), 'courseid'=>$courseid);
         $optionsno = array('userid'=>$existing->userid, 'courseid'=>$courseid);
-        print_header("$SITE->shortname: $strblogs", $SITE->fullname);
+        $PAGE->set_title("$SITE->shortname: $strblogs");
+        $PAGE->set_heading($SITE->fullname);
+        echo $OUTPUT->header();
         //blog_print_entry($existing);
         $existing->print_html();
         echo '<br />';
@@ -226,19 +228,11 @@
 
 $blog_headers = blog_get_headers();
 
-$navigation = build_navigation($blog_headers['navlinks'], $blog_headers['cm']);
-/*
-$navlinks = array();
-$navlinks[] = array('name' => fullname($user), 'link' => "$CFG->wwwroot/user/view.php?id=$userid", 'type' => 'misc');
-$navlinks[] = array('name' => $strblogs, 'link' => "$CFG->wwwroot/blog/index.php?userid=$userid", 'type' => 'misc');
-$navlinks[] = array('name' => $strformheading, 'link' => null, 'type' => 'misc');
-$navigation = build_navigation($navlinks);
-*/
 $PAGE->requires->js('blog/edit_form.js'); 
 $PAGE->set_title($blog_headers['title']);
 $PAGE->set_heading($blog_headers['title']);
 
-echo $OUTPUT->header($navigation);
+echo $OUTPUT->header();
 
 $blogeditform->set_data($entry);
 $blogeditform->display();
Index: moodle/blog/external.php
--- moodle/blog/external.php Base (1.2)
+++ moodle/blog/external.php Locally Modified (Based On 1.2)
@@ -113,16 +113,13 @@
     redirect($returnurl);
 }
 
-$navlinks = array();
-$navlinks[] = array('name' => fullname($user), 'link' => "$CFG->wwwroot/user/view.php?id=$user->id", 'type' => 'misc');
-$navlinks[] = array('name' => $strblogs, 'link' => "$CFG->wwwroot/blog/index.php?userid=$user->id", 'type' => 'misc');
-$navlinks[] = array('name' => $strformheading, 'link' => null, 'type' => 'misc');
-$navigation = build_navigation($navlinks);
-
+$PAGE->navbar->add(fullname($user), new moodle_url($CFG->wwwroot.'/user/view.php', array('id'=>$user->id)));
+$PAGE->navbar->add($strblogs, new moodle_url($CFG->wwwroot.'/blog/index.php', array('userid'=>$user->id)));
+$PAGE->navbar->add($strformheading);
 $PAGE->set_heading("$SITE->shortname: $strblogs: $strexternalblogs", $SITE->fullname);
 $PAGE->set_title("$SITE->shortname: $strblogs: $strexternalblogs");
 
-echo $OUTPUT->header($navigation);
+echo $OUTPUT->header();
 echo $OUTPUT->heading($strformheading, 2);
 
 $external->returnurl = $returnurl;
Index: moodle/blog/header.php
--- moodle/blog/header.php Base (1.61)
+++ moodle/blog/header.php Locally Modified (Based On 1.61)
@@ -99,12 +99,6 @@
 
 $blog_headers = blog_get_headers();
 
-if (isset($cm)) {
-    $navigation = build_navigation($blog_headers['navlinks'], $cm);
-} else {
-    $navigation = build_navigation($blog_headers['navlinks']);
-}
-
 // prints the tabs
 $showroles = !empty($userid);
 $currenttab = 'blogs';
Index: moodle/blog/lib.php
--- moodle/blog/lib.php Base (1.118)
+++ moodle/blog/lib.php Locally Modified (Based On 1.118)
@@ -518,7 +518,7 @@
     $action   = optional_param('action', null, PARAM_ALPHA);
     $confirm  = optional_param('confirm', false, PARAM_BOOL);
 
-    $headers = array('navlinks' => array(), 'title' => '', 'heading' => '', 'cm' => null);
+    $headers = array('title' => '', 'heading' => '', 'cm' => null);
 
     $blog_url = new moodle_url($CFG->wwwroot . '/blog/index.php');
     $site = $DB->get_record('course', array('id' => SITEID));
Index: moodle/blog/preferences.php
--- moodle/blog/preferences.php Base (1.25)
+++ moodle/blog/preferences.php Locally Modified (Based On 1.25)
@@ -67,15 +67,14 @@
 
 $strpreferences = get_string('preferences');
 $strblogs       = get_string('blogs', 'blog');
-$navlinks = array(array('name' => $strblogs, 'link' => "$CFG->wwwroot/blog/", 'type' => 'misc'));
-$navlinks[] = array('name' => $strpreferences, 'link' => null, 'type' => 'misc');
-$navigation = build_navigation($navlinks);
 
 $title = "$site->shortname: $strblogs : $strpreferences";
 $PAGE->set_title($title);
 $PAGE->set_heading($title);
+$PAGE->navbar->add($strblogs, new moodle_url($CFG->wwwroot.'/blog/'));
+$PAGE->navbar->add($strpreferences);
 
-echo $OUTPUT->header($navigation);
+echo $OUTPUT->header();
 
 echo $OUTPUT->heading("$strblogs : $strpreferences", 2);
 