diff -Naur es_utf8/conditional.php es_utf8-conditionals/conditional.php
--- es_utf8/conditional.php	1970-01-01 00:00:00.000000000 +0000
+++ es_utf8-conditionals/conditional.php	2009-09-16 14:14:00.000000000 +0100
@@ -0,0 +1,152 @@
+<?php
+$string['activateconditional'] = 'Activar condicional';
+$string['activities'] = 'Actividades';
+$string['activityinfo'] = 'Información de actividad';
+$string['activityinfocreation'] = 'Creación de la información de actividad para $a';
+$string['activitylocks'] = 'Condicionales';
+$string['addcondition'] = 'Añadir $a a agrupación de miembros';
+$string['agregateconditionswarning'] = 'Para que esta actividad quede condicionada debe introducir a continuación el número identificador de al menos una de las condiciones creadas';
+$string['agrupateconditions'] = 'Combinar las diferentes condiciones usando operadores lógicos';
+$string['assignmentgrade'] = 'Nota obtenida en la tarea';
+$string['assignmentgradeselect'] = 'Nota obtenida en la tarea: ';
+$string['assignmentparticulargrade'] = 'Nota obtenida en la tarea <B>$a</B> ';
+$string['assignmentparticularhasntsubmit'] = 'El alumno no ha enviado la tarea <B>$a</B> ';
+$string['assignmentparticularhassubmit'] = 'El alumno ha enviado la tarea <B>$a</B> ';
+$string['assignmentstudentgrade'] = 'La nota obtenida en <B>$a->instance</B> sea $a->op ';
+$string['assignmentstudenthasntsubmit'] = 'El alumno no ha enviado la tarea';
+$string['assignmentstudenthassubmit'] = 'El alumno ha enviado la tarea';
+$string['assignmentsubmit'] = 'Envio de la tarea';
+$string['bookparticipanthasaccess'] = 'El alumno ha accedido al libro ';
+$string['bookparticipanthasaccessdisplay'] = 'El alumno ha accedido al libro <B>$a</B> ';
+$string['bookparticipanthasntaccess'] = 'El alumno no ha accedido al libro ';
+$string['bookparticipanthasntaccessdisplay'] = 'El alumno no ha accedido al libro <B>$a</B> ';
+$string['chatparticularhasntparticipated'] = 'El alumno no ha participado en <B>$a</B> ';
+$string['chatparticularhasparticipated'] = 'El alumno ha participado en <B>$a</B> ';
+$string['chatstudenthasntparticipated'] = 'El alumno no ha participado en el chat';
+$string['chatstudenthasparticipated'] = 'El alumno ha participado en el chat';
+$string['choiceanyanswer'] = 'El alumno ha respondido a la consulta';
+$string['choiceanyanswerdisplay'] = 'El alumno ha respondido a la consulta <B>$a->instance</B>';
+$string['choiceparticularanswer'] = 'Respuesta dada a la consulta';
+$string['choiceparticularanswerdisplay'] = 'La respuesta dada a <B>$a->instance</B> sea $a->op $a->text';
+$string['choiceparticularansweris'] = 'Respuesta dada a la consulta <B>$a</B> sea ';
+$string['choiceselect'] = 'Escoja la consulta: ';
+$string['conditionalbookparticipanthasaccess'] = 'El alumno ha accedido al libro condicional ';
+$string['conditionalbookparticipanthasaccessdisplay'] = 'El alumno ha accedido al libro condicional <B>$a</B> ';
+$string['conditionalbookparticipanthasntaccess'] = 'El alumno no ha accedido al libro condicional ';
+$string['conditionalbookparticipanthasntaccessdisplay'] = 'El alumno no ha accedido al libro condicional <B>$a</B> ';
+$string['conditionaldisabled'] = '<b>Advertencia:</b> este condicional está desactivado y, por lo tanto, no se usará en el curso. Si quieres activarlo haz click en el botón \"Activar condicional\"';
+$string['conditioncreation'] = 'Creación de condiciones para $a';
+$string['condition'] = 'Condición';
+$string['conditions'] = 'Condiciones';
+$string['conditionscombination'] = 'Combinación de condiciones: ';
+$string['courseuselabel'] = 'Resaltar actividades nuevas';
+$string['createconditional'] = 'Guardar y crear condicional';
+$string['createconditionalandfinish'] = 'Botones Crear condicional y Finalizar';
+$string['createcondition'] = 'Crear nueva condición';
+$string['createdconditions'] = 'Condiciones creadas para $a';
+$string['date'] = 'Fecha';
+$string['datetimedifference'] = 'El tiempo transcurrido (en días) desde la fecha ';
+$string['datetimedifferencedisplay'] = 'El tiempo transcurrido desde la fecha $a->date sea $a->op $a->days días';
+$string['deactivateconditional'] = 'Desactivar condicional';
+$string['delete'] = 'Borrar';
+$string['deleteusedcondition'] = 'Se va a borrar una condición que está siendo utilizada. Esto hará que se borre la Combinación de condiciones (en la parte inferior de la página), con lo que esta actividad dejará de estar condicionada. Por lo tanto, deberá volver a crear la Combinación de condiciones en caso de que desee condicionar esta actividad. ¿Continuar de todas maneras?';
+$string['dialogueconversations'] = 'Número de diálogos iniciados';
+$string['dialogueparticularconversations'] = 'Número de diálogos iniciados en <B>$a</B> sea ';
+$string['dialogueparticipantconversations'] = 'El número de diálogos iniciados en <B>$a->instance</B> sea $a->op $a->value';
+$string['distinct'] = 'distinto de';
+$string['edit'] = 'Editar';
+$string['editingactivityinfo'] = 'Editando información de actividad';
+$string['editingconditionals'] = 'Editando condicionales';
+$string['editingview'] = 'Editando la vista del curso';
+$string['enrolment'] = 'Fecha del alta';
+$string['enrolmenttimedifference'] = 'El tiempo transcurrido (en días) desde la fecha de alta del alumno en el curso sea ';
+$string['enrolmenttimedifferencedisplay'] = 'El tiempo transcurrido desde la fecha de alta del alumno en el curso sea $a->op $a->days días';
+$string['equal'] = 'igual a';
+$string['forumanswers'] = 'Número de discusiones distintas en las que el alumno ha participado';
+$string['forumdiscussions'] = 'Temas iniciados por el alumno en el foro';
+$string['forumgrade'] = 'Calificación obtenida por el alumno en el foro';
+$string['forummessages'] = 'Mensajes del alumno en el foro';
+$string['forumconditionparticularanswers'] = 'El número de discusiones en las que se ha participado en <B>$a->instance</B> sea $a->op $a->value';
+$string['forumconditionparticulardiscussions'] = 'El número de discusiones iniciadas en <B>$a->instance</B> sea $a->op $a->value';
+$string['forumconditionparticulargrade'] = 'La calificación obtenida en el foro <B>$a->instance</B> sea $a->op ';
+$string['forumconditionparticularmessages'] = 'El número de mensajes colocados en <B>$a->instance</B> sea $a->op $a->value';
+$string['forumconditionparticularsuccess'] = 'El número de respuestas obtenidas en <B>$a->instance</B> sea $a->op $a->value';
+$string['forumparticularanswers'] = 'El número de discusiones en las que se ha participado en el foro <B>$a</B> sea: ';
+$string['forumparticulardiscussions'] = 'El número de discusiones iniciadas en el foro <B>$a</B> sea: ';
+$string['forumparticulargrade'] = 'La calificación obtenida por el alumno en el foro <B>$a</B> sea: ';
+$string['forumparticularmessages'] = 'El número de mensajes colocados en el foro <B>$a</B> sea: ';
+$string['forumparticularsuccess'] = 'El número de respuestas obtenidas en el foro <B>$a</B> sea: ';
+$string['forumsuccess'] = 'Número de respuestas a los mensajes del alumno';
+$string['finish'] = 'Finalizar';
+$string['general'] = 'General';
+$string['glossarycomments'] = 'Comentarios añadidos por el alumno al glosario';
+$string['glossaryconditionparticularcomments'] = 'El número de comentarios añadidos a <B>$a->instance</B> sea $a->op $a->value';
+$string['glossaryconditionparticularentries'] = 'El número de entradas añadidas a <B>$a->instance</B> sea $a->op $a->value';
+$string['glossaryentries'] = 'Entradas añadidas por el alumno al glosario';
+$string['glossaryparticularcomments'] = 'El número de comentarios hechos a términos del glosario <B>$a</B> sea ';
+$string['glossaryparticularentries'] = 'El número de entradas añadidas al glosario <B>$a</B> sea ';
+$string['greater'] = 'mayor que';
+$string['greaterequal'] = 'mayor o igual que';
+$string['id'] = 'Usar';
+$string['invalidsyntax'] = '<b>Se ha producido un error:</b> probablemente la sintaxis introducida o algún número identificador sean incorrectos. Debe revisar la \"Combinación de condiciones\"';
+$string['less'] = 'menor que';
+$string['lessequal'] = 'menor o igual que';
+$string['lessonanswer'] = 'Respuesta dada a una pregunta de la lección';
+$string['lessonconditiongrade'] = 'La nota obtenida en <B>$a->instance</B>, en porcentaje de la nota máxima posible, sea $a->op $a->value';
+$string['lessonessaygrade'] = 'La puntuación obtenida en la pregunta <B>$a</B> sea ';
+$string['lessongrade'] = 'Nota obtenida en la lección';
+$string['lessonmatchs'] = 'El número de emparejamientos correctos en la pregunta <B>$a</B> sea ';
+$string['lessonparticulargrade'] = 'La nota obtenida en la lección <B>$a</B>, en porcentaje de la máxima nota posible, sea ';
+$string['lessonquestionanswer'] = 'La respuesta dada a la pregunta <B>$a</B> sea ';
+$string['lessonquestionessay'] = 'La puntuación obtenida en la pregunta <B>$a->question</B> de <B>$a->instance</B> sea $a->op $a->value';
+$string['lessonquestionmatch'] = 'El número de emparejamientos correctos en la pregunta <B>$a->question</B> de <B>$a->instance</B> sea $a->op $a->value';
+$string['lessonquestionnumerical'] = 'La respuesta dada a la pregunta <B>$a->question</B> de <B>$a->instance</B> sea $a->op $a->value';
+$string['lessonquestionshort'] = 'La respuesta dada a la pregunta <B>$a->question</B> de <B>$a->instance</B> sea $a->op $a->answer';
+$string['lessonselectquestion'] = 'Escoja la pregunta deseada de la lección <B>$a</B>: ';
+$string['locked'] = '(Condicionada) ';
+$string['new'] = 'NUEVO';
+$string['newtitle'] = 'Aún no has visto este elemento del curso';
+$string['nocreatedconditions'] = 'Aún no se han creado condiciones';
+$string['notuseconditionals'] = 'No usar condicionales';
+$string['personalized'] = 'Si - etiqueta personalizada';
+$string['personalizedlabel'] = 'Etiqueta personalizada';
+$string['picture'] = 'Foto del participante';
+$string['picturehaschanged'] = 'El participante ha modificado su foto';
+$string['picturehasnotchanged'] = 'El participante no ha modificado su foto';
+$string['quizanswer'] = 'Respuesta dada a una pregunta del cuestionario';
+$string['quizconditiongrade'] = 'La nota obtenida en <B>$a->instance</B>, en porcentaje de la nota máxima posible, sea $a->op $a->value';
+$string['quizgrade'] = 'Nota obtenida en el cuestionario';
+$string['quizmatchs'] = 'El número de aciertos en la pregunta <B>$a</B> sea ';
+$string['quizparticulargrade'] = 'La nota obtenida en el cuestionario <B>$a</B>, en porcentaje de la máxima nota posible, sea ';
+$string['quizquestionanswer'] = 'La respuesta dada a la pregunta <B>$a</B> sea ';
+$string['quizquestionmatch'] = 'El número de emparejamientos correctos en la pregunta <B>$a->question</B> de <B>$a->instance</B> sea $a->op $a->value';
+$string['quizquestionnumerical'] = 'La respuesta dada a la pregunta <B>$a->question</B> de <B>$a->instance</B> sea $a->op $a->value';
+$string['quizquestionrandom'] = 'El número de aciertos en la pregunta <B>$a->question</B> de <B>$a->instance</B> sea $a->op $a->value';
+$string['quizquestionshort'] = 'La respuesta dada a la pregunta <B>$a->question</B> de <B>$a->instance</B> sea $a->op $a->answer';
+$string['quizselectquestion'] = 'Escoja la pregunta deseada del cuestionario <B>$a</B>: ';
+$string['resourcestudenthasaccess'] = 'El alumno ha accedido al recurso ';
+$string['resourcestudenthasaccessdisplay'] = 'El alumno ha accedido al recurso <B>$a</B> ';
+$string['resourcestudenthasntaccess'] = 'El alumno no ha accedido al recurso ';
+$string['resourcestudenthasntaccessdisplay'] = 'El alumno no ha accedido al recurso <B>$a</B> ';
+$string['role'] = 'Rol del participante';
+$string['roleparticular'] = 'El <B>rol</B> del usuario sea $a->op $a->value';
+$string['savecondition'] = 'Guardar condición';
+$string['selectactivitytype'] = 'Escoja el tipo de elemento al que se quiere condicionar: ';
+$string['startdate'] = 'Inicio del curso';
+$string['starttimedifference'] = 'El tiempo transcurrido (en días) desde la fecha de inicio del curso sea ';
+$string['starttimedifferencedisplay'] = 'El tiempo transcurrido desde la fecha de inicio del curso sea $a->op $a->days días';
+$string['studentlang'] = 'Idioma del alumno ';
+$string['studentlangparticular'] = 'El <B>idioma</B> del alumno sea $a->op $a->value';
+$string['studentcountry'] = 'Pais del alumno ';
+$string['studentcountryparticular'] = 'El <B>pais</B> del alumno sea $a->op $a->value';
+$string['useconditionals'] = 'Usar condicionales';
+$string['used'] = 'En uso';
+$string['userrole'] = 'El rol del usuario sea ';
+$string['wiki'] = 'El número de veces que el alumno ha editado el wiki ';
+$string['wikiis'] = ' sea ';
+$string['wikiparticular'] = 'El número de veces que el alumno ha editado <B>$a->instance</B> sea $a->op $a->value';
+$string['workshop'] = 'La nota (en porcentaje de la máxima nota posible) obtenida en el taller ';
+$string['workshopis'] = ' sea ';
+$string['workshopparticular'] = 'La nota obtenida en <B>$a->instance</B>, en porcentaje de la máxima nota posible, sea $a->op $a->value';
+$string['yes'] = 'Si - etiqueta NUEVO';
+?>
diff -Naur es_utf8/help/conditional/activityinfocreation.html es_utf8-conditionals/help/conditional/activityinfocreation.html
--- es_utf8/help/conditional/activityinfocreation.html	1970-01-01 00:00:00.000000000 +0000
+++ es_utf8-conditionals/help/conditional/activityinfocreation.html	2009-09-16 14:14:00.000000000 +0100
@@ -0,0 +1,3 @@
+<P ALIGN=CENTER><B>Creación de información de actividad</B></P>
+
+<P>Desde esta página se puede definir algún tipo de información relacionada con una actividad y que le aparecerá al alumno, en la página principal del curso y justo encima de la actividad en cuestión, hasta que acceda a dicha actividad. Una vez que el alumno haya accedido a la actividad se podrá acceder a esta información mediante el botón de ayuda que aparece al lado del nombre de la actividad.</P>
\ No hay ningún carácter de nueva línea al final del fichero
diff -Naur es_utf8/help/conditional/conditionalcreation.html es_utf8-conditionals/help/conditional/conditionalcreation.html
--- es_utf8/help/conditional/conditionalcreation.html	1970-01-01 00:00:00.000000000 +0000
+++ es_utf8-conditionals/help/conditional/conditionalcreation.html	2009-09-16 14:14:00.000000000 +0100
@@ -0,0 +1,78 @@
+<P ALIGN=CENTER><B>Creación de condiciones</B></P>
+
+<P>Desde este apartado puedes crear condicionales para lograr establecer un itinerario o ritmo de aprendizaje personalizado para cada alumno del curso. Las actividades o recursos se irán mostrando según la interacción del alumno con el curso. Es decir, gracias a los condicionales las actividades o recursos no aparecerán todos juntos sino en el momento adecuado sin que el tutor tenga que preocuparse de ir ocultándolas o haciéndolas visibles según la programación establecida.</P> 
+
+<P>La aparición o no de cualquier actividad puede condicionarse a una o varias de las condiciones descritas más abajo.</P>
+
+<P>El proceso requiere dos pasos:
+ 
+<ul>1.- crear una o varias condiciones eligiendo entre las diferentes opciones que se presentan</ul>
+<ul>2.- combinar las condiciones creadas utilizando operadores lógicos</ul>
+  
+<P>El resultado es que esta actividad o recurso no se mostrará a un alumno determinado hasta que no se cumplan, para dicho alumno, la combinación de condiciones previamente definida.</P>
+
+<P>Los tipos de condiciones disponibles son los siguientes:</P>
+
+<P><B>Tarea</B></P>
+<UL>Se puede condicionar a que el alumno haya o no enviado una tarea determinada del curso.</UL>
+<UL>Se puede condicionar a que la calificación obtenida por el alumno en una tarea determinada del curso sea igual, distinta, mayor, menor, mayor o igual o menor o igual que cualquier calificación posible para dicha tarea, ya sea un valor numérico o una escala personalizada.</UL>
+
+<P><B>Chat</B></P>
+<UL>Se puede condicionar a que el alumno haya o no participado en un chat determinado del curso.</UL>
+
+<P><B>Consulta</B></P>
+<UL>Se puede condicionar a que el alumno haya o no respondido a una consulta determinada del curso.</UL>
+<UL>Se puede condicionar a que la respuesta dada por el alumno a una consulta determinada del curso sea igual o distinta a cualquiera de las opciones de la consulta.</UL>
+
+<P><B>Foro</B></P>
+<UL>Se puede condicionar a que el número de discusiones (hilos) iniciadas por el alumno en un foro determinado del curso sea igual, distinto, mayor, menor, mayor o igual o menor o igual que un número del 0 al 100.</UL>
+<UL>Se puede condicionar a que el número de mensajes (los inicios de discusiones o hilos también se consideran mensajes) enviados por el alumno a un foro determinado del curso sea igual, distinto, mayor, menor, mayor o igual o menor o igual que un número del 0 al 100.</UL>
+<UL>Se puede condicionar a que el número de mensajes de respuesta (se contarán como mensajes de respuesta todos los mensajes que sean hijos, nietos, bisnietos, ... de los inicios de discusiones del alumno) obtenidos por el alumno en un foro determinado del curso sea igual, distinto, mayor, menor, mayor o igual o menor o igual que un número del 0 al 100, teniendo en cuenta que los mensajes de respuesta enviados por el propio alumno también se cuentan.</UL>
+<UL>Se puede condicionar a que la calificación obtenida por el alumno en un foro determinado del curso sea igual, distinta, mayor, menor, mayor o igual o menor o igual que cualquier calificación posible para dicho foro, ya sea un valor numérico o una escala personalizada.</UL>
+
+<P><B>Glosario</B></P>
+<UL>Se puede condicionar a que el número de entradas añadidas por el alumno a un glosario determinado del curso sea igual, distinto, mayor, menor, mayor o igual o menor o igual que un número del 0 al 100.</UL>
+<UL>Se puede condicionar a que el número de comentarios hechos por el alumno a términos de un glosario determinado del curso sea igual, distinto, mayor, menor, mayor o igual o menor o igual que un número del 0 al 100.</UL>
+
+<P><B>Lección</B></P>
+<UL>Se puede condicionar a que la calificación obtenida por el alumno en una lección determinada del curso sea igual, distinta, mayor, menor, mayor o igual o menor o igual que un porcentaje de la calificación máxima posible.</UL>
+<UL>Se puede condicionar a que la respuesta dada por el alumno a una pregunta de tipo "opción múltiple" determinada de una lección determinada del curso sea igual o distinta a cualquiera de las opciones posibles.</UL>
+<UL>Se puede condicionar a que la respuesta dada por el alumno a una pregunta de tipo "verdadero/falso" determinada de una lección determinada del curso sea igual o distinta a cualquiera de las dos opciones posibles.</UL>
+<UL>Se puede condicionar a que la respuesta dada por el alumno a una pregunta de tipo "respuesta corta" determinada de una lección determinada del curso sea igual o distinta a cualquiera de las respuestas posibles.</UL>
+<UL>Se puede condicionar a que la respuesta dada por el alumno a una pregunta de tipo "numérica" determinada de una lección determinada del curso sea igual, distinta, mayor, menor, mayor o igual o menor o igual que un número a introducir.</UL>
+<UL>Se puede condicionar a que el número de emparejamientos correctos hechos por el alumno en una pregunta de tipo "emparejando" determinada de una lección determinada del curso sea igual, distinto, mayor, menor, mayor o igual o menor o igual que un número entre 0 y el número de emparejamientos totales.</UL>
+<UL>Se puede condicionar a que la puntuación obtenida por el alumno en una pregunta de tipo "ensayo" determinada de una lección determinada del curso sea igual, distinta, mayor, menor, mayor o igual o menor o igual que un número entre 0 y la puntuación máxima posible.</UL>
+
+<P><B>Cuestionario</B></P>
+<UL>Se puede condicionar a que la calificación obtenida por el alumno en un cuestionario determinado del curso sea igual, distinta, mayor, menor, mayor o igual o menor o igual que un porcentaje de la calificación máxima posible.</UL>
+<UL>Se puede condicionar a que la respuesta dada por el alumno a una pregunta de tipo "respuesta corta" determinada de un cuestionario determinado del curso sea igual o distinta a cualquiera de las respuestas posibles.</UL>
+<UL>Se puede condicionar a que la respuesta dada por el alumno a una pregunta de tipo "verdadero/falso" determinada de un cuestionario determinado del curso sea igual o distinta a cualquiera de las dos opciones posibles.</UL>
+<UL>Se puede condicionar a que la respuesta dada por el alumno a una pregunta de tipo "opción múltiple" determinada de un cuestionario determinado del curso sea igual o distinta a cualquiera de las opciones posibles.</UL>
+<UL>Se puede condicionar a que el número de emparejamientos correctos hechos por el alumno en una pregunta de tipo "correspondencia" determinada de un cuestionario determinado del curso sea igual, distinto, mayor, menor, mayor o igual o menor o igual que un número entre 0 y el número de emparejamientos totales.</UL>
+<UL>Se puede condicionar a que el número de aciertos del alumno en una pregunta de tipo "emparejando respuestas cortas aleatoriamente" determinada de un cuestionario determinado del curso sea igual, distinto, mayor, menor, mayor o igual o menor o igual que un número entre 0 y el número de respuestas cortas totales.</UL>
+<UL>Se puede condicionar a que la respuesta dada por el alumno a una pregunta de tipo "numérica" determinada de un cuestionario determinado del curso sea igual, distinta, mayor, menor, mayor o igual o menor o igual que un número a introducir.</UL>
+<UL>Se puede condicionar a que la respuesta dada por el alumno a una pregunta de tipo "calculada" determinada de un cuestionario determinado del curso sea igual, distinta, mayor, menor, mayor o igual o menor o igual que la respuesta correcta.</UL>
+
+<P><B>Wiki</B></P>
+<UL>Se puede condicionar a que el número de veces que el alumno ha editado un wiki determinado del curso sea igual, distinto, mayor, menor, mayor o igual o menor o igual que un número del 0 al 100.</UL>
+
+<P><B>Taller</B></P>
+<UL>Se puede condicionar a que la calificación obtenida por el alumno en un taller determinado del curso sea igual, distinta, mayor, menor, mayor o igual o menor o igual que un porcentaje de la calificación máxima posible.</UL>
+
+<P><B>Recurso</B></P>
+<UL>Se puede condicionar a que el alumno haya accedido a un recurso del curso que no sea una etiqueta.</UL>
+
+<P><B>Idioma del alumno</B></P>
+<UL>Se puede condicionar a que el idioma del alumno sea distinto o igual a uno cualquiera de la lista de idiomas.</UL>
+
+<P><B>Pais del alumno</B></P>
+<UL>Se puede condicionar a que el país del alumno sea distinto o igual a uno cualquiera de la lista de paises.</UL>
+
+<P><B>Fecha de alta (primer clic)</B></P>
+<UL>Se puede condicionar a que el tiempo transcurrido desde el primer clic del alumno en el curso sea mayor o menor que un número de días determinado.</UL>
+
+<P><B>Fecha de inicio del curso</B></P>
+<UL>Se puede condicionar a que el tiempo transcurrido desde la fecha de inicio del curso sea mayor o menor que un número de días determinado.</UL>
+
+<P><B>Fecha cualquiera</B></P>
+<UL>Se puede condicionar a que el tiempo transcurrido desde una fecha concreta sea mayor o menor que un número de días determinado.</UL>
diff -Naur es_utf8/help/conditional/conditionalgrouping.html es_utf8-conditionals/help/conditional/conditionalgrouping.html
--- es_utf8/help/conditional/conditionalgrouping.html	1970-01-01 00:00:00.000000000 +0000
+++ es_utf8-conditionals/help/conditional/conditionalgrouping.html	2009-09-16 14:14:00.000000000 +0100
@@ -0,0 +1,7 @@
+<P ALIGN=CENTER><B>Combinación de condiciones</B></P>
+
+<P>En este apartado es en donde se agrupan las condiciones de la manera deseada. Para ello debe hacerse uso de los identificadores asociados a cada condición en la tabla del apartado anterior ("Condiciones creadas"), de paréntesis y de los conectores lógicos "and" ("Y" lógico), "or" ("O" lógico) y "not" ("Negación"). Usted puede introducir el texto directamente o bien haciendo clic en los identificadores de las condiciones (tabla de "Condiciones creadas") y en los botones "(", ")", "not", "and" y "or". Nótese que las condiciones creadas no se usarán hasta que no se agrupen aqui. A continuación se muestran algunos ejemplos con el fin de aclarar la sintaxis usada:</P>
+
+<P><B>1 and 2 and 3</B></P>
+<P><B>(1 and 2) or 3</B></P>
+<P><B>((1 or 2) and 3) or not 1</B></P>
\ No hay ningún carácter de nueva línea al final del fichero
diff -Naur es_utf8/help/conditional/conditionaltable.html es_utf8-conditionals/help/conditional/conditionaltable.html
--- es_utf8/help/conditional/conditionaltable.html	1970-01-01 00:00:00.000000000 +0000
+++ es_utf8-conditionals/help/conditional/conditionaltable.html	2009-09-16 14:14:00.000000000 +0100
@@ -0,0 +1,3 @@
+<P ALIGN=CENTER><B>Tabla de Condiciones creadas</B></P>
+
+<P>En la siguiente tabla se muestran las condiciones que se han creado hasta el momento. Nótese que estas condiciones no entrarán en funcionamiento hasta que no se agrupen en el apartado "Combinación de condiciones" más abajo en esta misma página. En la primera columna de la tabla aparecerá una marca indicando si cada condición se está usando (un "visto" verde) o no se está usando (una cruz roja). En la segunda columna aparece el condicional en si. En la tercera columna se muestra un número que sirve para identificar al condicional de cara a hacer el agrupamiento (ver ayuda de "Combinar las diferentes condiciones usando operadores lógicos" para más información). Al pinchar en cualquiera de los identificadores, este se añade al final de la caja de texto de "Combinación de condiciones".  Y las dos columnas siguientes sirven para editar y borrar cada una de las condiciones.</P>
diff -Naur es_utf8/help/conditional/courseuselabel.html es_utf8-conditionals/help/conditional/courseuselabel.html
--- es_utf8/help/conditional/courseuselabel.html	1970-01-01 00:00:00.000000000 +0000
+++ es_utf8-conditionals/help/conditional/courseuselabel.html	2009-09-16 14:14:00.000000000 +0100
@@ -0,0 +1,3 @@
+<P ALIGN=CENTER><B>Resaltar actividades nuevas</B></P>
+
+<P>Si elige la opción <b>Si - etiqueta NUEVO</b> se mostrará resaltada la palabra <b>NUEVO</b> junto al nombre de las actividades a las que el alumno nunca haya accedido y si elige la opción <b>Si - etiqueta personalizada</b> se mostrará resaltado el texto que se introduzca en el campo <b>Etiqueta personalizada</b> (a continuación en esta misma pantalla de configuración del curso) junto al nombre de las actividades a las que el alumno nunca haya accedido.</P>
diff -Naur es_utf8/help/conditional/personalizedlabel.html es_utf8-conditionals/help/conditional/personalizedlabel.html
--- es_utf8/help/conditional/personalizedlabel.html	1970-01-01 00:00:00.000000000 +0000
+++ es_utf8-conditionals/help/conditional/personalizedlabel.html	2009-09-16 14:14:00.000000000 +0100
@@ -0,0 +1,3 @@
+<P ALIGN=CENTER><B>Etiqueta personalizada</B></P>
+
+<P>Cuando se introduce un texto en este campo y se elige la opción <b>Si - etiqueta personalizada</b> en el campo <b>Resaltar actividades nuevas</b> (es una opción anterior de esta misma pantalla de configuración del curso), el texto introducido se mostrará resaltado junto al nombre de las actividades a las que el alumno nunca haya accedido.</P>
diff -Naur es_utf8/help/index.html es_utf8-conditionals/help/index.html
--- es_utf8/help/index.html	2009-09-16 14:16:26.000000000 +0100
+++ es_utf8-conditionals/help/index.html	2009-09-16 14:14:00.000000000 +0100
@@ -79,3 +79,15 @@
   <li><a href="help.php?file=richtext.html">Usar el Editor de Texto HTML Enriquecido</a></li>
   <li><a href="help.php?file=emoticons.html">Usar emoticonos</a></li>
 </ul>
+
+<!-- START CONDITIONALS -->
+<h2>Cursos con condicionales</h2>
+<ul>
+  <li><a href="help.php?file=conditional/conditionalcreation.html">Creación de condiciones</a></li>
+  <li><a href="help.php?file=conditional/conditionalgrouping.html">Combinación de condiciones</a></li>
+  <li><a href="help.php?file=conditional/conditionaltable.html">Tabla de condiciones creadas</a></li>
+  <li><a href="help.php?file=conditional/courseuselabel.html">Resaltar actividades nuevas</a></li>
+  <li><a href="help.php?file=conditional/personalizedlabel.html">Etiqueta personalizada</a></li>
+  <li><a href="help.php?file=conditional/activityinfocreation.html">Creación de información de actividad</a></li>
+</ul>
+<!-- END CONDITIONALS -->